{% extends 'base.html' %}
{% load bootstrap5 %}
{% load static %}

{% block title %}
    {% if question.is_answered %}
        Вопрос (решён):
    {% else %}
        Вопрос:
    {% endif %}
    "{{ question.title }}"
{% endblock %}'

{% block content %}
    {% if not user.is_authenticated %}
        <svg xmlns="http://www.w3.org/2000/svg" style="display: none;">
          <symbol id="info-fill" fill="currentColor" viewBox="0 0 16 16">
            <path d="M8 16A8 8 0 1 0 8 0a8 8 0 0 0 0 16zm.93-9.412-1 4.705c-.07.34.029.533.304.533.194 0 .487-.07.686-.246l-.088.416c-.287.346-.92.598-1.465.598-.703 0-1.002-.422-.808-1.319l.738-3.468c.064-.293.006-.399-.287-.47l-.451-.081.082-.381 2.29-.287zM8 5.5a1 1 0 1 1 0-2 1 1 0 0 1 0 2z"/>
          </symbol>
        </svg>
        <div class="alert alert-warning alert-dismissible fade show" role="alert">
            <svg class="bi flex-shrink-0 me-2" width="24" height="24" role="img" aria-label="Info:"><use xlink:href="#info-fill"/></svg>
            Чтобы проголосовать или ответить на вопрос, выполните <a href="/user/login">вход</a>
            <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
        </div>
    {% endif %}

    {# форма голосования #}
    <form id="vote_question" action="#">
        <input type="hidden" id="question" name="question" />
        {% csrf_token %}
    </form>
    <form id="vote_answer" action="#">
        <input type="hidden" id="answer" name="answer" />
        {% csrf_token %}
    </form>

    <div class="d-flex py-3">
        <div class="card d-flex flex-column w-100">
            <div class="card-header{% if question.is_answered %} bg-success bg-gradient opacity-75{% endif %}">
                <div class="row">
                    <div class="col">
                        {% if user.profile.avatar %}
                            <img src="{{ question.user.profile.avatar.url }}" width="48" height="48" class="rounded-circle me-3" alt="{{ question.user.username }}">
                        {% else %}
                            <img src="/files/avatar.svg" width="48" height="48" class="rounded-circle me-3" alt="{{ question.user.username }}">
                        {% endif %}
                        <span class="fs-7"><span class="badge bg-secondary rounded-pill">{{ question.user }}</span></span>
                    </div>
                    <div class="col text-end">
                        {% for tag in question.tags.all %}
                            <a href="/qa/?search=tag:{{ tag }}" class="badge bg-secondary rounded-pill link-light">{{ tag }}</a>
                        {% endfor %}
                    </div>
                </div>
            </div>
            <div class="card-body">
                <span class="text-start fs-3" style="white-space: pre-line">{{ question.text }}</span>
            </div>
            <div class="card-footer">
                <div class="row">
                    <div class="col">
                        <small class="fs-7 text-small">Создан:  <span class="badge bg-secondary rounded-pill">{{ question.created }}</span></small>
                    </div>
                    <div class="col text-end">
                        <small class="fs-7">Обновлён: <span class="badge bg-secondary rounded-pill">{{ question.updated }}</span></small>
                    </div>
                </div>
            </div>
        </div>
        {% if user.is_authenticated %}
            <div class="d-flex flex-column px-2" style="width: 120px;">
                <button class="btn btn-outline-secondary" onclick="vote_question({{ question.id }}, '1')">+</button>
                <b id="question_score" class="fs-3 text-center">{{ question.score }}</b>
                <button class="btn btn-outline-secondary" onclick="vote_question({{ question.id }}, '-1')">-</button>
            </div>
        {% endif %}
    </div>
    {% if lines %}
        <span class="text-start fs-3 py-3">Ответы на вопрос</span>
        {% for answer in lines %}
            <div class="d-flex py-3">
                <div class="card d-flex lex-column w-100">
                    <div class="card-header{% if answer.is_answered %} bg-success bg-gradient opacity-75{% endif %}">
                        <div class="row">
                            <div class="col">
                                {% if answer.user.profile.avatar %}
                                    <img src="{{ answer.user.profile.avatar.url }}" width="48" height="48" class="rounded-circle me-3" alt="{{ answer.user.username }}">
                                {% else %}
                                    <img src="/files/avatar.svg" width="48" height="48" class="rounded-circle me-3" alt="{{ answer.user.username }}">
                                {% endif %}
                                <b>{{ answer.user }}</b>
                            </div>
                            <div class="col text-end">{{ answer.created }}</div>
                        </div>
                    </div>
                    <div class="card-body">
                        <span class="card-text" style="white-space: pre-line">{{ answer.text }}</span>
                    </div>
                    {% if answer.is_answered %}
                        <div class="card-footer bg-success bg-gradient opacity-75">Автор вопроса отметил этот ответ правильным</div>
                    {% endif %}
                </div>
                {% if user.is_authenticated %}
                    <div class="d-flex flex-column px-3" style="width: 80px;">
                        <button class="btn btn-outline-secondary" onclick="vote_answer({{ answer.id }}, '1')">+</button>
                        <b id="answer_{{ answer.id }}_score" class="fs-5 text-center">{{ answer.score }}</b>
                        <button class="btn btn-outline-secondary" onclick="vote_answer({{ answer.id }}, '-1')">-</button>
                    </div>
                {% endif %}
            </div>
            {% if not question.is_answered and user.id == question.user_id %}
                <a class="btn btn-outline-secondary" href="{% url 'qa:correct_answer' answer.id %}">Отметить этот ответ как правильный</a>
            {% endif %}
        {% endfor %}
    {% else %}
        <span class="text-start fs-3 py-3">Ответов пока что нет. Есть что ответить?</span>
    {% endif %}

    {% if lines.paginator.num_pages > 1 %}
        {% bootstrap_pagination lines url="?page=1" size="large" %}
    {% endif %}

    {% if user.is_authenticated %}
        <div class='py-3'>
            <form method="POST">
                {% csrf_token %}
                {% bootstrap_form form %}
                <button class="btn btn-primary" type="submit">Создать</button>
            </form>
        </div>
    {% endif %}

    <script src="{% static 'js/script.js' %}"></script>
{% endblock %}
